diff --git a/libpurple/purplerequestfield.c b/libpurple/request/purplerequestfieldaccount.c
copy from libpurple/purplerequestfield.c
copy to libpurple/request/purplerequestfieldaccount.c
--- a/libpurple/purplerequestfield.c
+++ b/libpurple/request/purplerequestfieldaccount.c
@@ -1434,233 +190,106 @@ purple_request_field_account_new(const c
 		}
 	}
 
-	purple_request_field_account_set_default_value(field, account);
-	purple_request_field_account_set_value(field, account);
-
-	return field;
+	return g_object_new(PURPLE_TYPE_REQUEST_FIELD_ACCOUNT,
+	                    "id", id,
+	                    "label", text,
+	                    "default-value", account,
+	                    "value", account,
+	                    NULL);
 }
 
 void
-purple_request_field_account_set_default_value(PurpleRequestField *field,
-											 PurpleAccount *default_value)
+purple_request_field_account_set_default_value(PurpleRequestFieldAccount *field,
+                                               PurpleAccount *default_value)
 {
-	PurpleRequestFieldPrivate *priv = NULL;
+	g_return_if_fail(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field));
 
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	priv->u.account.default_account = default_value;
+	if(g_set_object(&field->default_account, default_value)) {
+		g_object_notify_by_pspec(G_OBJECT(field),
+		                         properties[PROP_DEFAULT_VALUE]);
+	}
 }
 
 void
-purple_request_field_account_set_value(PurpleRequestField *field,
-									 PurpleAccount *value)
+purple_request_field_account_set_value(PurpleRequestFieldAccount *field,
+                                       PurpleAccount *value)
 {
-	PurpleRequestFieldPrivate *priv = NULL;
+	g_return_if_fail(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field));
 
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	priv->u.account.account = value;
+	if(g_set_object(&field->account, value)) {
+		g_object_notify_by_pspec(G_OBJECT(field), properties[PROP_VALUE]);
+	}
 }
 
 void
-purple_request_field_account_set_show_all(PurpleRequestField *field,
-										gboolean show_all)
+purple_request_field_account_set_show_all(PurpleRequestFieldAccount *field,
+                                          gboolean show_all)
 {
-	PurpleRequestFieldPrivate *priv = NULL;
+	g_return_if_fail(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field));
 
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	if(priv->u.account.show_all == show_all) {
+	if(field->show_all == show_all) {
 		return;
 	}
 
-	priv->u.account.show_all = show_all;
+	field->show_all = show_all;
+
+	g_object_freeze_notify(G_OBJECT(field));
 
 	if(!show_all) {
 		PurpleAccountManager *manager = purple_account_manager_get_default();
 		GList *accounts = purple_account_manager_get_connected(manager);
 
-		if(purple_account_is_connected(priv->u.account.default_account)) {
+		if(purple_account_is_connected(field->default_account)) {
 			purple_request_field_account_set_default_value(field,
 			                                               accounts->data);
 		}
 
-		if(purple_account_is_connected(priv->u.account.account)) {
-			purple_request_field_account_set_value(field,
-			                                       accounts->data);
+		if(purple_account_is_connected(field->account)) {
+			purple_request_field_account_set_value(field, accounts->data);
 		}
 
 		g_list_free(accounts);
 	}
+
+	g_object_notify_by_pspec(G_OBJECT(field), properties[PROP_SHOW_ALL]);
+
+	g_object_thaw_notify(G_OBJECT(field));
 }
 
 void
-purple_request_field_account_set_filter(PurpleRequestField *field,
-									  PurpleFilterAccountFunc filter_func)
+purple_request_field_account_set_filter(PurpleRequestFieldAccount *field,
+                                        PurpleFilterAccountFunc filter_func)
 {
-	PurpleRequestFieldPrivate *priv = NULL;
+	g_return_if_fail(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field));
 
-	g_return_if_fail(PURPLE_IS_REQUEST_FIELD(field));
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT);
-
-	priv->u.account.filter_func = filter_func;
+	field->filter_func = filter_func;
 }
 
 PurpleAccount *
-purple_request_field_account_get_default_value(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
+purple_request_field_account_get_default_value(PurpleRequestFieldAccount *field)
+{
+	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field), NULL);
 
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, NULL);
-
-	return priv->u.account.default_account;
+	return field->default_account;
 }
 
 PurpleAccount *
-purple_request_field_account_get_value(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
+purple_request_field_account_get_value(PurpleRequestFieldAccount *field) {
+	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field), NULL);
 
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, NULL);
-
-	return priv->u.account.account;
+	return field->account;
 }
 
 gboolean
-purple_request_field_account_get_show_all(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
+purple_request_field_account_get_show_all(PurpleRequestFieldAccount *field) {
 	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
 
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, FALSE);
-
-	return priv->u.account.show_all;
+	return field->show_all;
 }
 
 PurpleFilterAccountFunc
-purple_request_field_account_get_filter(PurpleRequestField *field) {
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_ACCOUNT, FALSE);
-
-	return priv->u.account.filter_func;
-}
-
-PurpleRequestField *
-purple_request_field_datasheet_new(const char *id,
-	const gchar *text, PurpleRequestDatasheet *sheet)
-{
-	PurpleRequestField *field;
-	PurpleRequestFieldPrivate *priv = NULL;
-
-	g_return_val_if_fail(id != NULL, NULL);
-	g_return_val_if_fail(sheet != NULL, NULL);
-
-	field = purple_request_field_new(id, text, PURPLE_REQUEST_FIELD_DATASHEET);
-	priv = purple_request_field_get_instance_private(field);
-
-	priv->u.datasheet.sheet = sheet;
-
-	return field;
-}
-
-PurpleRequestDatasheet *
-purple_request_field_datasheet_get_sheet(PurpleRequestField *field)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-
+purple_request_field_account_get_filter(PurpleRequestFieldAccount *field) {
 	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
 
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_DATASHEET, NULL);
-
-	return priv->u.datasheet.sheet;
-}
-
-/* -- */
-
-gboolean
-purple_request_field_email_validator(PurpleRequestField *field, gchar **errmsg,
-                                     G_GNUC_UNUSED gpointer user_data)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-	const char *value;
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, FALSE);
-
-	value = purple_request_field_string_get_value(field);
-
-	if (value != NULL && purple_email_is_valid(value))
-		return TRUE;
-
-	if (errmsg)
-		*errmsg = g_strdup(_("Invalid email address"));
-	return FALSE;
+	return field->filter_func;
 }
-
-gboolean
-purple_request_field_alphanumeric_validator(PurpleRequestField *field,
-	gchar **errmsg, void *allowed_characters)
-{
-	PurpleRequestFieldPrivate *priv = NULL;
-	const char *value;
-	gchar invalid_char = '\0';
-
-	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), FALSE);
-
-	priv = purple_request_field_get_instance_private(field);
-	g_return_val_if_fail(priv->type == PURPLE_REQUEST_FIELD_STRING, FALSE);
-
-	value = purple_request_field_string_get_value(field);
-
-	g_return_val_if_fail(value != NULL, FALSE);
-
-	if (allowed_characters)
-	{
-		gchar *value_r = g_strdup(value);
-		g_strcanon(value_r, allowed_characters, '\0');
-		invalid_char = value[strlen(value_r)];
-		g_free(value_r);
-	}
-	else
-	{
-		while (value)
-		{
-			if (!g_ascii_isalnum(*value))
-			{
-				invalid_char = *value;
-				break;
-			}
-			value++;
-		}
-	}
-	if (!invalid_char)
-		return TRUE;
-
-	if (errmsg)
-		*errmsg = g_strdup_printf(_("Invalid character '%c'"),
-			invalid_char);
-	return FALSE;
-}
diff --git a/libpurple/purplerequestpage.c b/libpurple/purplerequestpage.c
--- a/libpurple/purplerequestpage.c
+++ b/libpurple/purplerequestpage.c
@@ -23,6 +23,7 @@
 
 #include "glibcompat.h"
 #include "purplerequestpage.h"
+#include "request/purplerequestfieldaccount.h"
 #include "purpleprivate.h"
 
 struct _PurpleRequestPage {
@@ -351,9 +352,10 @@ purple_request_page_get_account(PurpleRe
 	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 	g_return_val_if_fail(id     != NULL, NULL);
 
-	if((field = purple_request_page_get_field(page, id)) == NULL) {
+	field = purple_request_page_get_field(page, id);
+	if(!PURPLE_IS_REQUEST_FIELD_ACCOUNT(field)) {
 		return NULL;
 	}
 
-	return purple_request_field_account_get_value(field);
+	return purple_request_field_account_get_value(PURPLE_REQUEST_FIELD_ACCOUNT(field));
 }
diff --git a/pidgin/gtkrequest.c b/pidgin/gtkrequest.c
--- a/pidgin/gtkrequest.c
+++ b/pidgin/gtkrequest.c
@@ -268,7 +268,8 @@ field_account_cb(GObject *obj, G_GNUC_UN
 	PidginAccountChooser *chooser = PIDGIN_ACCOUNT_CHOOSER(obj);
 
 	purple_request_field_account_set_value(
-	        field, pidgin_account_chooser_get_selected(chooser));
+	        PURPLE_REQUEST_FIELD_ACCOUNT(field),
+	        pidgin_account_chooser_get_selected(chooser));
 
 	req_field_changed_common(GTK_WIDGET(obj), field);
 }
@@ -1083,8 +1084,8 @@ setup_entry_field(GtkWidget *entry, Purp
 				PurpleRequestField *fld = fields->data;
 				fields = fields->next;
 
-				if (purple_request_field_get_field_type(fld) == PURPLE_REQUEST_FIELD_ACCOUNT &&
-						purple_request_field_is_visible(fld))
+				if(PURPLE_IS_REQUEST_FIELD_ACCOUNT(fld) &&
+				   purple_request_field_is_visible(fld))
 				{
 					const char *type_hint = purple_request_field_get_type_hint(fld);
 					if (purple_strequal(type_hint, "account"))
@@ -1316,15 +1317,17 @@ field_custom_account_filter_cb(gpointer 
 static GtkWidget *
 create_account_field(PurpleRequestField *field)
 {
+	PurpleRequestFieldAccount *afield = NULL;
 	GtkWidget *widget = NULL;
 	PurpleAccount *account = NULL;
 	PurpleFilterAccountFunc account_filter = NULL;
 	GtkFilter *filter = NULL;
 
 	widget = pidgin_account_chooser_new();
-	account  = purple_request_field_account_get_default_value(field);
-
-	account_filter = purple_request_field_account_get_filter(field);
+	afield = PURPLE_REQUEST_FIELD_ACCOUNT(field);
+	account = purple_request_field_account_get_default_value(afield);
+
+	account_filter = purple_request_field_account_get_filter(afield);
 	if(account_filter != NULL) {
 		GtkCustomFilter *custom_filter = NULL;
 
@@ -1334,7 +1337,7 @@ create_account_field(PurpleRequestField 
 		filter = GTK_FILTER(custom_filter);
 	}
 
-	if(!purple_request_field_account_get_show_all(field)) {
+	if(!purple_request_field_account_get_show_all(afield)) {
 		GtkEveryFilter *every = NULL;
 
 		every = gtk_every_filter_new();
@@ -2144,9 +2147,9 @@ pidgin_request_fields(const char *title,
 						widget = create_list_field(field);
 					else if (type == PURPLE_REQUEST_FIELD_IMAGE)
 						widget = create_image_field(field);
-					else if (type == PURPLE_REQUEST_FIELD_ACCOUNT)
+					else if(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field)) {
 						widget = create_account_field(field);
-					else if (type == PURPLE_REQUEST_FIELD_DATASHEET)
+					} else if (type == PURPLE_REQUEST_FIELD_DATASHEET)
 						widget = create_datasheet_field(field, datasheet_buttons_sg);
 					else
 						continue;
